<?xml version="1.0"?>
<launch>
  <arg name="open_rviz" default="true"/>
  <arg name="load_state_filename" default="$(find cartographer_launcher)/maps/amrx-exp.pbstream" />
  <arg name="configuration_basename" default="turtlebot3_lds_pure2d_exp_nav.lua"/>
  <arg name="urdf_file" default="xacro '$(find arlobot_description)/urdf/common_default_t265.urdf.xacro'"/>
  <param name="robot_description" command="$(arg urdf_file)"/>
  <rosparam param="ticks_meter">300</rosparam>
  <rosparam param="base_width">0.393</rosparam>
  <node name="robot_state_publisher" pkg="robot_state_publisher" type="robot_state_publisher"/>
  <include file="$(find cartographer_launcher)/launch/rs_t265.launch"/>


  <!-- <node pkg="laser_filters" type="scan_to_scan_filter_chain" name="laser_filter">
    <rosparam command="load" file="$(find cartographer_launcher)/config/rplidar_laser_config.yaml" />
</node> -->


  <!-- Arguments -->
  <arg name="scan_topic" default="scan"/>

  <!-- Rplidar node -->
  <node name="rplidarNode" pkg="rplidar_ros" type="rplidarNode">
    <param name="serial_port" type="string" value="/dev/ttyUSB0"/>
    <param name="serial_baudrate" type="int" value="115200"/>
    <!--A1/A2 -->
    <param name="frame_id" type="string" value="neato_laser"/>
    <param name="inverted" type="bool" value="false"/>
    <param name="angle_compensate" type="bool" value="true"/>
  </node>

  <include file="$(find cartographer_launcher)/launch/arlobot_move_base_dwa.launch">
  </include>

  <!-- diff drive nodes -->
  <node pkg="differential_drive" type="diff_tf.py" name="diff_tf_node">
    <rosparam param="base_frame_id">"base_footprint"</rosparam>
    <rosparam param="rate">30</rosparam>
    <remap from="rwheel" to="rwheel"/>
    <remap from="lwheel" to="lwheel"/>
    <remap from="odom" to="wheel_odom"/>
  </node>

  <node pkg="differential_drive" type="twist_to_motors.py" name="twist_to_motors">
  </node>

  <!-- cartographer_node -->
  <node pkg="cartographer_ros" type="cartographer_node" name="cartographer_node" args="-configuration_directory $(find cartographer_launcher)/config               -configuration_basename $(arg configuration_basename)               -load_state_filename $(arg load_state_filename)">
    <remap from="imu" to="/rs_t265/imu" />
    <remap from="odom" to="/rs_t265/odom/sample"/>

  </node>
  <!-- cartographer_occupancy_grid_node -->
  <node pkg="cartographer_ros" type="cartographer_occupancy_grid_node" name="cartographer_occupancy_grid_node" args="-resolution 0.05"/>

  <node pkg="cartographer_launcher" name="emergency_stop" type="people_control.py" output="log">
  </node>

  <node pkg="amr_arlo_encoders" name="encoders_node" type="main2.py" output="log">
    <param name="encoders_port" type="string" value="/dev/ttyUSB1"/>
    <param name="serial_baudrate" type="int" value="115200"/>
  </node>

</launch>
